const require_chunk = require('./chunk-CUT6urMc.cjs');
const require_logger = require('./logger-C0V8Cvvd.cjs');
const require_resolvePluginOptions = require('./resolvePluginOptions-Da5uqlBx.cjs');
const __pengzhanbo_utils = require_chunk.__toESM(require("@pengzhanbo/utils"));
const node_path = require_chunk.__toESM(require("node:path"));
const node_process = require_chunk.__toESM(require("node:process"));
const __rspack_core = require_chunk.__toESM(require("@rspack/core"));

//#region src/rspack.ts
const PLUGIN_NAME = "rspack-plugin-mock";
var MockServerPlugin = class {
	constructor(options = {}) {
		this.options = options;
	}
	apply(compiler) {
		const compilerOptions = compiler.options;
		const options = resolvePluginOptions$1(compiler, this.options);
		if (node_process.default.env.NODE_ENV !== "production") {
			const mockCompiler = require_resolvePluginOptions.createMockCompiler(options);
			const mockMiddleware = require_resolvePluginOptions.createMockMiddleware(mockCompiler, options);
			const setupMiddlewares = compilerOptions.devServer?.setupMiddlewares;
			const waitServerForMockWebSocket = require_logger.waitingFor((server) => {
				require_logger.mockWebSocket(mockCompiler, server, options);
			});
			compilerOptions.devServer = {
				...compilerOptions.devServer,
				setupMiddlewares: (middlewares, devServer) => {
					middlewares = setupMiddlewares?.(middlewares, devServer) || middlewares;
					const reload = () => {
						if (devServer.webSocketServer?.clients) devServer.sendMessage(devServer.webSocketServer.clients, "static-changed");
					};
					middlewares = mockMiddleware(middlewares, reload) || middlewares;
					/**
					* 在 @rspack/dev-server -> webpack-dev-server 中, setupMiddlewares 优先于 createServer
					* 执行，需要等待 server 启动后再注入 mock websocket
					*/
					waitServerForMockWebSocket(() => devServer.server);
					return middlewares;
				}
			};
			const wsPrefix = (0, __pengzhanbo_utils.toArray)(options.wsPrefix);
			if (compilerOptions.devServer?.proxy?.length) {
				const proxy = compilerOptions.devServer.proxy;
				compilerOptions.devServer.proxy = proxy.filter((item) => {
					if (typeof item !== "function" && item.ws === true && wsPrefix.length) return !(0, __pengzhanbo_utils.toArray)(item.context).filter(__pengzhanbo_utils.isString).some((context) => wsPrefix.includes(context));
					return true;
				}).map((item) => {
					if (typeof item !== "function" && !item.ws) {
						const onProxyReq = item.onProxyReq;
						item.onProxyReq = (proxyReq, req, ...args) => {
							onProxyReq?.(proxyReq, req, ...args);
							require_logger.rewriteRequest(proxyReq, req);
						};
					}
					return item;
				});
			}
			compiler.hooks.watchRun.tap(PLUGIN_NAME, () => mockCompiler.run());
			compiler.hooks.watchClose.tap(PLUGIN_NAME, () => mockCompiler.close());
		} else if (options.build !== false) compiler.hooks.afterEmit.tap(PLUGIN_NAME, () => require_resolvePluginOptions.buildMockServer(options, compilerOptions.output.path || node_path.default.resolve(node_process.default.cwd(), "dist")));
	}
};
function resolvePluginOptions$1(compiler, options = {}) {
	const compilerOptions = compiler.options;
	const alias = compilerOptions.resolve?.alias || {};
	const context = compilerOptions.context;
	const definePluginInstance = compilerOptions.plugins?.find((plugin) => plugin instanceof __rspack_core.default.DefinePlugin);
	const proxies = (compilerOptions.devServer?.proxy || []).flatMap((item) => {
		if (typeof item !== "function" && item.context && !item.ws) return item.context;
		return [];
	});
	return require_resolvePluginOptions.resolvePluginOptions(options, {
		alias,
		context,
		plugins: (0, __pengzhanbo_utils.toArray)(definePluginInstance),
		proxies
	});
}

//#endregion
exports.MockCompiler = require_resolvePluginOptions.MockCompiler;
exports.MockServerPlugin = MockServerPlugin;
exports.createMockCompiler = require_resolvePluginOptions.createMockCompiler;
exports.createMockMiddleware = require_resolvePluginOptions.createMockMiddleware;
exports.mockWebSocket = require_logger.mockWebSocket;
exports.resolvePluginOptions = resolvePluginOptions$1;