import { MockHttpItem, MockOptions, MockServerPluginOptions, MockWebsocketItem } from "./types-DPzh7nJq.js";
import { Logger, Middleware, MockCompiler, MockSocketOptions, createLogger, logLevels, mockWebSocket } from "./mockWebsocket-qLVAe-RI.js";

//#region src/core/baseMiddleware.d.ts
interface BaseMiddlewareOptions {
  formidableOptions: MockServerPluginOptions["formidableOptions"];
  cookiesOptions: MockServerPluginOptions["cookiesOptions"];
  bodyParserOptions: MockServerPluginOptions["bodyParserOptions"];
  proxies: (string | ((pathname: string, req: any) => boolean))[];
  logger: Logger;
  priority: MockServerPluginOptions["priority"];
}
declare function baseMiddleware(compiler: MockCompiler, {
  formidableOptions,
  bodyParserOptions,
  proxies,
  cookiesOptions,
  logger,
  priority
}: BaseMiddlewareOptions): Middleware;
//#endregion
//#region src/core/transform.d.ts
declare function transformRawData(rawData: (readonly [any, string])[]): (MockHttpItem | MockWebsocketItem | MockOptions)[];
declare function transformMockData(mockList: (MockHttpItem | MockWebsocketItem | MockOptions)[]): Record<string, MockOptions>;
declare function sortByValidator(mocks: MockOptions): (MockHttpItem | MockWebsocketItem)[];
//#endregion
export { BaseMiddlewareOptions, Logger, MockSocketOptions, baseMiddleware, createLogger, logLevels, mockWebSocket, sortByValidator, transformMockData, transformRawData };